蜗牛789
主机测评与优惠

解决网站程序和插件\”preg_replace\”报错问题



提示:如果官网是英文页面,建议使用谷歌浏览器能同步翻译页面。点击下载【谷歌浏览器最新绿色便携版】
注意:部分文章发布时间较长,可能存在未知因素,购买时建议现在本博客搜索商家名称,先充分了解商家动态。
交流:唯一投稿QQ490898739、唯一投稿邮箱490898739@qq.com、网友交流QQ群号1074630828。

蜗牛刚才在迁移一个客户企业网站的时候发现有报错提示\”preg_replace()\”函数错误,后面一长长的字符串我就没有记录下来总之就是这个报错。我看这个企业网站客户是使用的很早的ECSHOP CMS程序做的,一般我们都知道的企业网站只要保持正常的可以能打开,基本不需要动。

但是目前技术也在增进,服务器配置的软件也在提高。比如我们目前是使用的PHP7.4,至少也要使用PHP7.3,但是我估计是函数在PHP版本兼容问题。后来我查询资料发现,这个\”preg_replace\”只有在PHP5.6及以下才兼容的。

这里我想到三个解决方案:

第一、更换程序

我个人建议是让业务去找客户谈一谈,是否这么多年网站也不适应时代需求,是否可以换一个自适应的,以及当前美观度习惯的。如果这样的话,我们可以给他重新做一个网站,兼容PHP最新版本。

第二、修改程序

这里我们也可以看到,ECSHOP看到类似问题还是很多的。

includes/cls_template.php

在这个文件中找到:

return preg_replace(\”/{([^\\}\\{\\n]*)}/e\”, \”\\$this->select(\’\\\\1\’);\”, $source);

然后替换成:

return preg_replace_callback(\”/{([^\\}\\{\\n]*)}/\”, function($r) { return $this->select($r[1]); }, $source);

应该是可以解决的,这里我找到解决办法是可以用的。

第三、搭建适配环境

我们单独用一台服务器搭建PHP较低版本的,然后给客户单独存放。这样就显得浪费服务器资源。

这个是目前可以解决的办法,等业务问问客户是否更换网站,我们建议他更新适应当前版本PHP最新版本比较好,效率也高。

About 蜗牛

【声明】:本博客不参与任何交易,也非中介,仅记录个人感兴趣的主机测评结果和优惠活动,内容均不作直接、间接、法定、约定的保证。访问本博客请务必遵守有关互联网的相关法律、规定与规则。一旦您访问本博客,即表示您已经知晓并接受了此声明通告。

赞(0) 打赏
未经允许不得转载:蜗牛789 » 解决网站程序和插件\”preg_replace\”报错问题


评论 抢沙发

  • 昵称 (必填)
  • 邮箱 (必填)
  • 网址

觉得文章有用就打赏一下文章作者

支付宝扫一扫打赏

微信扫一扫打赏